<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      // Person (firstName, lastName, group)
      // - can make coffee
      // - can come to workspace
      // - can use wifi

      // Student id
      // - can attend lessons
      //
      // Teacher -> Trainer, Mentor
      // - get student results

      // Trainer
      // - teach students

      // Mentor
      // - estimate homework
      // function Person(firstName, lastName) {
      //   this.firstName = firstName;
      //   this.lastName = lastName;

      // }

      class Person {
        constructor(firstName, lastName) {
          this.firstName = firstName;
          this.lastName = lastName;
        }

        makeCoffee() {
          console.log(`${this.firstName} is making black coffee`);
        }

        useWifi() {
          console.log(`${this.firstName} is connected to wifi`);
        }
      }

      const newPerson = new Person("ira", "sto");
      console.log(newPerson);

      class Student extends Person {
        constructor(firstName, lastName, id, group) {
          super(firstName, lastName);
          this.group = group;
          this.id = id;
        }
        attendLessons() {
          console.log(`${this.firstName} is attending lessons`);
        }
      }

      const maria = new Student('Maria', "Surname", "Stee", "fe3");
      console.log(maria)
      maria.makeCoffee();
      maria.attendLessons();



      class Teacher extends Person {
        constructor(firstName, lastName) {
          super(firstName, lastName);
        }
        makeCoffee() {
          super.makeCoffee();
          console.log(`${this.firstName} is inside teacher`);
        }
      };


      const teacher = new Teacher();
      console.log(teacher)
      teacher.makeCoffee()

      class Mentor extends Teacher {
        constructor(firstName, lastName, isOnline) {
          super(firstName, lastName);
          this.isOnline = isOnline;
        }
        estimateHomework() {
          console.log(`${this.firstName} is estimating homework`);
        }
      }

      const teacher = new Mentor();
      console.log(teacher)
      teacher.makeCoffee()
      // console.log(maria);
      // maria.makeCoffee();
      // maria.useWifi();
      // maria.attendLessons();

      // const irina = new Teacher("Irina", "Stoe", "fe3");
      // console.log(irina);
      // // irina.makeCoffee()
      // irina.makeCoffee = function () {
      //   console.log("error");
      // };
      // console.log(irina);
      // irina.makeCoffee();
      // irina.useWifi();

      // irina.makeCoffee();
      // const katya = new Mentor("Katya", "Step", true);
      // katya.estimateHomework();
    </script>
  </body>
</html>
